package sample2;

import jp.kwebs.Csv;


public record Population(String prefecture, int population, double rate ) {

	// デフォルトのコンストタラクタにチェック機能を追加する
	public Population {
		if(prefecture==null) {
			throw new RuntimeException();
		}
	}
	
	// コンストラクタのオーバーロード
	public Population(String prefecture, int population) {
		this(prefecture, population, 0);
	}
	
	// インスタンスメソッド／人口増減率がプラスの時trueを返す
	public boolean isPlus() {
		return rate > 0;
	}
	
	// クラスメソッド／CSVオブジェクトを受け取ってインスタンスを返す
	public static Population of(Csv csv) {
		return new Population( csv.get(0),			// 都道府県名
								csv.getInt(1),		// 人口
								csv.getDouble(2));	// 人口増減率
	}
}
