package sample;
import static java.util.stream.Collectors.*;
import java.util.Comparator;
import java.util.List;
import java.util.Optional;

public class CalculatingExample {
	public static void main(String[] args) {
		
		List<Book> list = Book.getList();
		// 件数
		long count = list.stream().collect(counting());
		// 合計
		int sum = list.stream()
				.collect(summingInt(Book::price));
		// 平均
		double ave = list.stream()
				.collect(averagingInt(Book::price));
		// 最大値
		Optional<Book> max = list.stream()
				.collect(maxBy(Comparator.comparing(Book::price)));
		// 最小値
		Optional<Book> min = list.stream()
				.collect(minBy(Comparator.comparing(Book::price)));

		System.out.println("件　数＝" + count);
		System.out.println("合　計＝" + sum);
		System.out.println("平　均＝" + ave);
		System.out.println("最高値＝" + max.get());
		System.out.println("最安値＝" + min.get());
	}
}
